<?php 
if ( ! defined( 'WPINC' ) ) {
	die();
} 
if ( ! function_exists( 'filebase_AddFolderToAttachments' ) ) :
add_action( 'init', 'filebase_AddFolderToAttachments' );
function filebase_AddFolderToAttachments(){
	register_taxonomy(	FILEBASE_TAX_FOLDER, 
		array( "attachment" ), 
		array(  "hierarchical" 		=> true, 
			    "labels"			=> array(
					'name'          		=> esc_html__('Folder', FILEBASE_TEXT_DOMAIN),
					'singular_name' 		=> esc_html__('Folder', FILEBASE_TEXT_DOMAIN),
					'add_new_item'			=> esc_html__('Add New Folder', FILEBASE_TEXT_DOMAIN),
					'edit_item' 			=> esc_html__('Edit Folder', FILEBASE_TEXT_DOMAIN),
					'new_item' 				=> esc_html__('Add New Folder', FILEBASE_TEXT_DOMAIN),
					'search_items' 			=> esc_html__('Search Folder', FILEBASE_TEXT_DOMAIN),
					'not_found' 			=> esc_html__('Folder not found', FILEBASE_TEXT_DOMAIN),
					'not_found_in_trash' 	=> esc_html__('Folder not found in trash', FILEBASE_TEXT_DOMAIN),
				), 
				'show_ui' 			=> true,
				'show_in_menu' 		=> false,
				'show_in_nav_menus'	=> false,
				'show_in_quick_edit'=> false,
				'update_count_callback' => '_update_generic_term_count',
				'show_admin_column'	=> false,
				"rewrite" 			=> false )
	);
}
endif;

if ( ! function_exists( 'filebase_set_valid_term_name' ) ) :
function filebase_set_valid_term_name($name, $parent){
    if (!$parent) {
        $parent = 0;
    }
    $terms = get_terms(FILEBASE_TAX_FOLDER, array('parent' => $parent, 'hide_empty' => false));
    $check = true;
    if (count($terms)) {
        foreach ($terms as $term) {
            if ($term->name === $name) {
                $check = false;
                break;
            }
        }
    } else {
        return $name;
    }
    if ($check) {
        return $name;
    }
    $arr = explode('_', $name);
    if ($arr && count($arr) > 1) { 
        $suffix = array_values(array_slice($arr, -1))[0];
        array_pop($arr);
        $origin_name = implode($arr);
        if (intval($suffix)) {
            $name = $origin_name . '_' . (intval($suffix) + 1);
        }
    } else {
        $name = $name . '_1';
    }

    $name = filebase_set_valid_term_name($name, $parent);

    return $name;
}
endif;
if ( ! function_exists( 'filebase_getNumberOfpostNoTerm' ) ) :
function filebase_getNumberOfpostNoTerm(){
    $keys = 'ids';
    $media_terms = get_terms( FILEBASE_TAX_FOLDER, array(
        'hide_empty' => 0,
        'fields'     => 'id=>slug',
    ));
    $media_values = array();
    foreach ( $media_terms as $key => $value ) 
    {
        $media_values[] = ( $keys === 'ids' )
            ? $key
            : $value;
    }
    $args = array(
            'post_type'         => 'attachment',
            'post_status'       => 'inherit,private',
            'posts_per_page'    => -1,
            'tax_query'         => Array
                (
                    'relation'  => 'AND',
                    0 => Array
                        (
                            'taxonomy'  => FILEBASE_TAX_FOLDER,
                            'field'     => 'id',
                            'terms'     =>  $media_values,
                            'operator'  => 'NOT IN'
                        )
                )
    );
    $result = get_posts($args);
    return $count1 = count($result);
}
endif;
if ( ! function_exists( 'filebase_GetNumbOfTerm' ) ) :
function filebase_GetNumbOfTerm(){
    $all_count = wp_count_posts('attachment')->inherit;
    return $all_count;
}
endif;
if ( ! function_exists( 'filebase_GetListTerm' ) ) :
add_action('wp_ajax_filebase_Get_List_Term', 'filebase_GetListTerm');
function filebase_GetListTerm(){

    $terms = get_terms(FILEBASE_TAX_FOLDER, array(
        'hide_empty' => false,
        'meta_key' 		=> 'folder_position',
		'orderby' 		=> 'meta_value'
    ));
   
    $filter= '';
    foreach ($terms as $key => $term) {
        $filter.= '<option value="'.$term->term_taxonomy_id.'">'.$term->name.'</option>';
    }

    ob_start();
    ?>
    <div class="hmh_filebase_toolbar wrap">
        <h1 class="wp-heading-inline">Media Folders</h1>
        <a id="add-new-folder" class="hmh-button-newfolder page-title-action bb-folder-custom-middle"><span class="filebase-iconcreate_new_folder bb-folder-custom-icon"></span> <span>Add Folder</span></a>
        <div class="hmh-function-button media-toolbar wp-filter">
            <div data-tippy-content="<?php esc_html_e('Edit Folder', 'bestbug'); ?>" >
                <button id="rename-folder" disabled class="hmh-button-rename button bb-folder-custom-middle" ><span class="filebase-iconmode_edit bb-folder-custom-icon"></span></button>
            </div>
            <div data-tippy-content="<?php esc_html_e('Delete Folder', 'bestbug'); ?>">
                <button id="delete-folder" disabled class="hmh-button-delete button bb-folder-custom-middle"><span class="filebase-icondelete bb-folder-custom-icon"></span></button>
            </div> 
            <div data-tippy-content="<?php esc_html_e('Expand All Folders', 'bestbug'); ?>">
                <button id="expand-folder" class="hmh-button-expand button bb-folder-custom-middle"><span class="filebase-iconunfold_more bb-folder-custom-icon"></span></button>
            </div>
            <div data-tippy-content="<?php esc_html_e('Collapse All Folder', 'bestbug'); ?>">
                <button id="collapse-folder" class="hmh-button-collapse button bb-folder-custom-middle"><span class="filebase-iconunfold_less bb-folder-custom-icon"></span></button>
            </div>
            
            <i class="hmh_load_ajax hmh_load_ajax_unable"></i>
            <span class="hmh-filter-folder">
                <span class="hmh-filter-folder-dot">
                </span>
                <ul class="hmh_popup_filter">
                    <li class="order-asc">
                        <span class="filebase-iconsort_by_alpha"></span>
                        <span>Order by ASC</span>
                    </li>
                    <li class="order-dasc">
                        <span class="filebase-iconsort_by_alpha_desc"></span>
                        <span>Order by DESC</span>
                    </li>
                    <!-- <li class="hmh-manual">
                        <span>Help</span>
                    </li> -->
                </ul>
            </span>
        </div>
        <div class="hmh_file jstree scrollbar-macosx">
            <ul class="hmh-folder-ul">
            <li id="hmh-all" data-cookie="-2" class="hmh_base_file hmh_all_folder ui-state-disabled hmh-didnHasChild" aria-selected="true">
                <a class="hmh-a-folder">
                    <i class="hmh-icon-folder filebase-iconfolder_home"></i>
                    <span class="hmh-term-name">All Files</span>
                    <strong class="hmh_number_of_attachment"><?php echo esc_html(filebase_GetNumbOfTerm()) ?></strong>
                </a>
            </li>
            <li id="hmh--1" data-cookie="-1" class="hmh_base_file folder-item ui-state-disabled hmh-didnHasChild " data-id="unset" aria-selected="false">
                <a class="hmh-a-folder">
                    <i class="hmh-icon-folder filebase-iconfolder_uncat"></i>
                    <span class="hmh-term-name">Uncategorized</span>
                    <strong class="hmh_number_of_attachment"><?php echo esc_html(filebase_getNumberOfpostNoTerm()) ?></strong>
                </a>
            </li>
            <li class="hmh-search-folder ui-state-disabled mjs-nestedSortable-no-nesting">
                <input type="text">
            </li>
            <li class="hmh-HR ui-state-disabled mjs-nestedSortable-no-nesting"></li>
            <?php  echo filebase_listTerm($terms, 0) ?>
            </ul>
        </div>
    </div>

    <?php
    $html =  ob_get_contents();
    ob_end_clean();
    
    wp_send_json_success(array($html,$filter,$terms));

    echo $html;

    wp_die();
}
endif;
if ( ! function_exists( 'filebase_GetListTermByOder' ) ) :
add_action('wp_ajax_filebase_Get_List_Term_By_Oder', 'filebase_GetListTermByOder');
function filebase_GetListTermByOder(){
    $terms = get_terms(FILEBASE_TAX_FOLDER, array(
        'hide_empty' => false,
        'orderby' 		=> 'name',
        'order' => $_POST['order'],
    ));
    ob_start();
    ?>
    <ul class="hmh-folder-ul">
        <li id="hmh-all" class="hmh_base_file hmh_all_folder ui-state-disabled hmh-didnHasChild" aria-selected="true" data-cookie="-2" >
            <a class="hmh-a-folder">
                <i class="hmh-open-folder hmh-closed"></i>
                <i class="hmh-icon-folder filebase-iconfolder active"></i>
                <span class="hmh-term-name">All Files</span>
                <strong class="hmh_number_of_attachment"><?php echo esc_html(filebase_GetNumbOfTerm()) ?></strong>
            </a>
        </li>
        <li id="hmh--1" class="hmh_base_file folder-item ui-state-disabled hmh-didnHasChild " data-id="unset" aria-selected="false" data-cookie="-1" >
            <a class="hmh-a-folder">
                <i class="hmh-open-folder hmh-closed"></i>
                <i class="hmh-icon-folder filebase-iconfolder"></i>
                <span class="hmh-term-name">Uncategorized</span>
                <strong class="hmh_number_of_attachment"><?php echo esc_html(filebase_getNumberOfpostNoTerm()) ?></strong>
            </a>
        </li>
        <li class="hmh-search-folder ui-state-disabled mjs-nestedSortable-no-nesting">
            <input type="text">
        </li>
        <li class="hmh-HR ui-state-disabled mjs-nestedSortable-no-nesting"></li>
        <?php  echo filebase_listTerm($terms, 0) ?>
    </ul>
    <?php
    $html =  ob_get_contents();
    ob_end_clean();
    echo $html;
    function position($n){
        $m = '9';
        for ($i=0; $i < $n ; $i++) { 
            $m .= '9';
        }
        return $m;
    }
    foreach ($terms as $key => $term) {
        update_term_meta($term->term_id, 'folder_position', position($key));
    }
    wp_die();
}
endif;
if ( ! function_exists( 'filebase_listTerm' ) ) :
function filebase_listTerm($terms, $valu){
    ob_start();
    foreach ($terms as $key => $term) {
        if ($term->parent==$valu) {
            ?>
            <li id="hmh-<?php echo esc_html($term->term_id) ?>" aria-selected="false" data-cookie="<?php echo esc_html($term->term_id) ?>"  data-id="<?php echo esc_html($term->term_id) ?>" class="folder-item-<?php echo esc_html($term->term_id) ?> folder-item hmh_base_file mjs-nestedSortable-collapsed" >
                <a class="hmh-a-folder">
                    <i class="hmh-open-folder filebase-iconfolder_parrent "></i>
                    <i class="hmh-icon-folder filebase-iconfolder"></i>
                    <span class="hmh-term-name"><?php echo esc_html($term->name) ?></span>
                    <strong class="hmh_number_of_attachment"><?php echo esc_html( filebase_GetNumberAttachment($term->term_id) ) ?></strong>
                </a>
                <ul class="hmh-children-folder">
                    <?php echo filebase_listTerm($terms, $term->term_id) ?>
                </ul>
            </li>
            <?php
        }
    }
    $html =  ob_get_contents();
    ob_end_clean();
    return $html;
}
endif;
if ( ! function_exists( 'filebase_GetNumberAttachment' ) ) :
function filebase_GetNumberAttachment($id){
    $query = get_term($id , FILEBASE_TAX_FOLDER );
    return $query->count;
}
endif;

if ( ! function_exists( 'filebase_set_object_terms' ) ) :
add_action('wp_ajax_filebase_set_object_terms', 'filebase_set_object_terms');
function filebase_set_object_terms(){
    $object_id = $_POST["object_id"];
    $terms = $_POST["terms"];

    $oldTerm = get_the_terms( $object_id, FILEBASE_TAX_FOLDER );

    if (!$oldTerm) :
        if ($terms==="unset"):
            wp_send_json_success(array('donotwork',$terms,$object_id,'donotwork','1.1'));
            wp_die();
        else:
            $setterm = wp_set_post_terms( $object_id, $terms, FILEBASE_TAX_FOLDER, false );
            if (is_wp_error($setterm)) {
                echo "error";
            } else {
                wp_send_json_success(array($setterm,$terms,$object_id,'unset','1.2'));
                wp_die();
            }
        endif;
    elseif ($oldTerm[0]->term_id==$terms):
        wp_send_json_success(array('donotwork',$terms,$object_id,'donotwork','2.1'));
        wp_die();
    else:
        if ($terms==="unset"):
            $unsetterm = wp_delete_object_term_relationships( $object_id, FILEBASE_TAX_FOLDER);
            if (is_wp_error($unsetterm)) {
                echo "error";
            } else {
                wp_send_json_success(array($unsetterm,$terms,$object_id,$oldTerm[0]->term_id,'3.1'));
                wp_die();
            }
        else:
            wp_delete_object_term_relationships( $object_id, FILEBASE_TAX_FOLDER);
            $setterm = wp_set_post_terms( $object_id, $terms, FILEBASE_TAX_FOLDER, false );
            if (is_wp_error($setterm)) {
                echo "error";
            } else {
                wp_send_json_success(array($setterm,$terms,$object_id,$oldTerm[0]->term_id,'3.2'));
                wp_die();
            }
        endif;
    endif;
    wp_die();
}
endif;
// anh9ok
if ( ! function_exists( 'filebase_set_multi_object_terms' ) ) :
add_action('wp_ajax_filebase_set_multi_object_terms', 'filebase_set_multi_object_terms');
function filebase_set_multi_object_terms(){
        $object_ids = $_POST["object_ids"];
        $terms = $_POST["terms"];
        $response = array();
        foreach ($object_ids as $key => $object_id) {
            $oldTerm = get_the_terms( $object_id, FILEBASE_TAX_FOLDER );
            if (!$oldTerm) :
                if ($terms==="unset"): 
                    array_push($response,array('donotwork',$terms,$object_id,'donotwork','1.1'));
                else:
                    $setterm = wp_set_post_terms( $object_id, $terms, FILEBASE_TAX_FOLDER, false );
                    if (is_wp_error($setterm)) {
                        echo "error";
                    } else {
                        array_push($response,array($setterm,$terms,$object_id,'unset','1.2'));
                    }
                endif;
            elseif ($oldTerm[0]->term_id==$terms):
                array_push($response,array('donotwork',$terms,$object_id,'donotwork','2.1'));
            else:
                if ($terms==="unset"):
                    $unsetterm = wp_delete_object_term_relationships( $object_id, FILEBASE_TAX_FOLDER);
                    if (is_wp_error($unsetterm)) {
                        echo "error";
                    } else {
                        array_push($response,array($unsetterm,$terms,$object_id,$oldTerm[0]->term_id,'3.1'));
                    }
                else:
                    wp_delete_object_term_relationships( $object_id, FILEBASE_TAX_FOLDER);
                    $setterm = wp_set_post_terms( $object_id, $terms, FILEBASE_TAX_FOLDER, false );
                    if (is_wp_error($setterm)) {
                        echo "error";
                    } else {
                        array_push($response,array($setterm,$terms,$object_id,$oldTerm[0]->term_id,'3.2'));
                    }
                endif;
            endif;
        }
        wp_send_json_success($response);
        wp_die();
}
endif;

if ( ! function_exists( 'filebase_ajax_update_folder_list_callback' ) ) :
add_action('wp_ajax_filebase_ajax_update_folder_list', 'filebase_ajax_update_folder_list_callback');
function filebase_ajax_update_folder_list_callback(){
        $arrayFolder = $_POST["arrayFolder"];
        $current = $_POST["current"];
        $new_name = $_POST["new_name"];
        $parent = $_POST["parent"];
        $type = $_POST["type"];
        $term_id = $_POST["term_id"];
        switch ($type) {
            case 'new':
                $name = filebase_set_valid_term_name($new_name, $parent);
                $term_new = wp_insert_term($name, FILEBASE_TAX_FOLDER, array(
                    'name' => $name,
                    'parent' => $parent,
                ));
                if (is_wp_error($term_new)) {
                    echo "error";
                } else {
                    if ($term_id) {
                        $check_error = wp_update_term($term_new["term_id"], FILEBASE_TAX_FOLDER, array(
                            'parent' =>$term_id,
                        ));
                    }
                    if ($term_id) {
                        wp_send_json_success(array($term_new,'term_id' => $term_new["term_id"], 'term_name' => $name,'hasparent'));
                    } else {
                        wp_send_json_success(array($term_new,'term_id' => $term_new["term_id"], 'term_name' => $name,'noparent'));
                    }
                }

                break;
            case 'rename':
                $check_error = wp_update_term($current, FILEBASE_TAX_FOLDER, array(
                    'name' => $new_name,
                ));
                if (is_wp_error($check_error)) {
                    echo "error";
                }else{
                    wp_send_json_success($check_error);
                }
                break;
            case 'move':
                function position($n){
                    $m = '9';
                    for ($i=0; $i < $n ; $i++) { 
                        $m .= '9';
                    }
                    return $m;
                }
                foreach ($arrayFolder as $key => $value) {
                    $check = update_term_meta($value["id"], 'folder_position', position($key));
                    if (is_wp_error($check)) {
                        echo "error";
                    }
                   
                    if ($value["parent_id"] !=0 ) {
                        $check_error = wp_update_term($value["id"], FILEBASE_TAX_FOLDER, array(
                            'parent' => $value["parent_id"],
                        ));
                        if (is_wp_error($check_error)) {
                            echo "error";
                        }
                    }else{
                        $check_error = wp_update_term($value["id"], FILEBASE_TAX_FOLDER, array(
                            'parent' => 0,
                        ));
                        if (is_wp_error($check_error)) {
                            echo "error";
                        }
                    }
                }

                break;
            case 'delete':
                $term = get_term( $current, FILEBASE_TAX_FOLDER );
                $check_error = wp_delete_term($current, FILEBASE_TAX_FOLDER);
                if (is_wp_error($check_error)) {
                    echo "error";
                }else{
                    wp_send_json_success($term);
                }
                break;
        }
        die();
}
endif;
if ( ! function_exists( 'filebase_add_position_new_term' ) ) :
function filebase_add_position_new_term( $term_id, $tt_id, $taxonomy ){
    $listTerms = get_terms(FILEBASE_TAX_FOLDER, array(
        'hide_empty' => false,
        'meta_key' 		=> 'folder_position',
        'orderby' 		=> 'meta_value'
    ));
    update_term_meta($term_id, 'folder_position', 1);
    foreach ($listTerms as $key => $value) {
        update_term_meta($value->term_id, 'folder_position', $key*1+2);
    }
}
add_action( 'create_term', 'filebase_add_position_new_term', 10, 3 );
endif;
if ( ! function_exists( 'filebase_pre_upload_ui' ) ) :
add_filter('pre-upload-ui', 'filebase_pre_upload_ui');
function filebase_pre_upload_ui(){
    global $pagenow;
    $terms = filebase_term_tree_array(FILEBASE_TAX_FOLDER, 0);
    $options = filebase_term_tree_option($terms);
    $label = esc_html__("Select a folder and upload files (Optional)", FILEBASE_TEXT_DOMAIN);
    echo '<p class="attachments-category">' . $label . '<br/></p>
        <p>
            <select name="filebaseULFolder" class="hmh-editcategory-filter"><option value="-1">' . esc_html__('Uncategorized', FILEBASE_TEXT_DOMAIN) . '</option>' . $options . '</select>
        </p>';
}
endif;

if ( ! function_exists( 'filebase_restrictManagePosts' ) ) :
add_filter('restrict_manage_posts','filebase_restrictManagePosts');
function filebase_restrictManagePosts(){
    $scr = get_current_screen();
    if ($scr->base !== 'upload') {
        return;
    }
    
    $html ='<select id="media-attachment-filters" class="filebaseMediacategory-filterr attachment-filters" name="filebase_hmh_folder">';
    $html .='<option value="">All files</option>';
    $html .='<option value="-1">Uncategorized</option>';
    $html .='</select>';
    echo $html;
}
endif;


if ( ! function_exists( 'filebase_term_tree_array' ) ) :
function filebase_term_tree_array($taxonomy, $parent){

    $terms = get_terms($taxonomy, array(
        'hide_empty' => false,
        'parent' => $parent,
    ));
    $children = array();
    foreach ($terms as $term) {
        $term->children = filebase_term_tree_array($taxonomy, $term->term_id);
        $children[] = $term;
    }
    return $children;
}
endif;

if ( ! function_exists( 'filebase_term_tree_option' ) ) :
function filebase_term_tree_option($terms, $spaces = ""){

    $html = '';

    if (!is_null($terms) && count($terms) > 0) {
        foreach ($terms as $item) {
            $html .= '<option value="' . $item->term_id . '" data-id="' . $item->term_id . '">' . $spaces . '&nbsp;' . $item->name . '</option>';

            if (is_array($item->children) && count($item->children) > 0) {
                $html .= filebase_term_tree_option($item->children, $spaces . '--');
            }
        }
    }
    return $html;
}
endif;

if ( ! function_exists( 'filebase_postsClauses' ) ) :
add_filter('posts_clauses', 'filebase_postsClauses', 10, 2);
function filebase_postsClauses($clauses, $query){
    global $wpdb;
    if (isset($_GET['filebase_hmh_folder'])) 
    {
        $folder = sanitize_text_field($_GET['filebase_hmh_folder']);
        if (!empty($folder) != '') 
        {
            $folder = (int)$folder;

            if ($folder > 0) 
            {
                $clauses['where'] .= ' AND ('.$wpdb->prefix.'term_relationships.term_taxonomy_id = '.$folder.')';
                $clauses['join'] .= ' LEFT JOIN '.$wpdb->prefix.'term_relationships ON ('.$wpdb->prefix.'posts.ID = '.$wpdb->prefix.'term_relationships.object_id)';
            } 
            else 
            {
                
                $folders = get_terms(FILEBASE_TAX_FOLDER, array(
                    'hide_empty' => false
                ));
                if($folders){
                    $folder_ids = array();
                    foreach ($folders as $k => $folder) 
                    {
                        $folder_ids[] = $folder->term_taxonomy_id;
                    }
                    
                    $folder_ids = esc_sql($folder_ids);
                    
                    $files_have_folder_query = "SELECT `ID` FROM ".$wpdb->prefix."posts LEFT JOIN ".$wpdb->prefix."term_relationships ON (".$wpdb->prefix."posts.ID = ".$wpdb->prefix."term_relationships.object_id) WHERE (".$wpdb->prefix."term_relationships.term_taxonomy_id IN (".implode(', ', $folder_ids)."))";
                    $clauses['where'] .= " AND (".$wpdb->prefix."posts.ID NOT IN (".$files_have_folder_query."))";
                }
            }
        }
    }    
    return $clauses;
}
endif;

if ( ! function_exists( 'filebase_admin_body_class' ) ) :
add_filter( 'admin_body_class', 'filebase_admin_body_class' );

function filebase_admin_body_class( $classes ) {
    return $classes . " wpehf-media-folder-manager";
}
endif;

if ( ! function_exists( 'filebase_AjaxQueryAttachmentsArgs' ) ) :
add_filter( 'ajax_query_attachments_args','filebase_AjaxQueryAttachmentsArgs');
function filebase_AjaxQueryAttachmentsArgs( $query = array() ) {
    $taxquery           = isset( $_REQUEST['query'] ) ? (array) $_REQUEST['query'] : array();
    $taxonomies         = get_object_taxonomies( 'attachment', 'names' );
    $taxquery           = array_intersect_key( $taxquery, array_flip( $taxonomies ) );
    $query              = array_merge( $query, $taxquery );
    $query['tax_query'] = array( 'relation' => 'AND' );
    foreach ( $taxonomies as $taxonomy ) 
    {
        if ( isset( $query[$taxonomy] ) && is_numeric( $query[$taxonomy] ) ) 
        {
            if ( $query[ $taxonomy ] > 0 ) 
            {
                array_push( $query['tax_query'], array(
                    'taxonomy' => $taxonomy,
                    'field'    => 'id',
                    'terms'    => $query[$taxonomy],
                    'include_children'  => false
                ));
            }
            else
            {
                $all_terms_ids = filebase_GetTermsValues( 'ids' );
                array_push( $query[ 'tax_query' ], array(
                    'taxonomy' => $taxonomy,
                    'field'    => 'id',
                    'terms'    => $all_terms_ids,
                    'operator' => 'NOT IN',
                ) );
            }
            
        }
        unset( $query[$taxonomy] );
    }
    return $query;
}
endif;

if ( ! function_exists( 'filebase_GetTermsValues' ) ) :
function filebase_GetTermsValues( $keys = 'ids' ) 
    {
    $media_terms = get_terms( FILEBASE_TAX_FOLDER, array(
        'hide_empty' => 0,
        'fields'     => 'id=>slug',
    ) );
    $media_values = array();
    
    foreach ( $media_terms as $key => $value ) 
    {
        $media_values[] = ( $keys === 'ids' )
            ? $key
            : $value;
    }
    return $media_values;
}
endif;

if ( ! function_exists( 'filebase_getTermTaxonomiID' ) ) :
add_action('wp_ajax_filebase_get_Term_Taxonomi_ID', 'filebase_getTermTaxonomiID');
function filebase_getTermTaxonomiID(){
    $termID = $_POST["termID"];
    $checkERROR = get_term_by('id', $termID, FILEBASE_TAX_FOLDER);
    if (is_wp_error($checkERROR)) {
        echo "error";
    } else {
        wp_send_json_success($checkERROR);
    }
    wp_die();
}
endif;

if ( ! function_exists( 'filebase_getfolderChild' ) ) :
add_action('wp_ajax_filebase_getfolderChild', 'filebase_getfolderChild');
function filebase_getfolderChild(){
    $parent = $_POST["parent"];
    $type = $_POST["type"];
    if ($type==='taxonomy') {
        $valu = get_term_by('term_taxonomy_id', $parent, FILEBASE_TAX_FOLDER );
        $parent = $valu->term_id;
    }
    $checkERROR = get_terms(FILEBASE_TAX_FOLDER, array(
        'hide_empty' => false,
        'parent'    =>$parent,
    ));

    $html ='';
    $html .='<li id="hmh-children-folder"><ul>';
    foreach ($checkERROR as $key => $child) {
       $html .='<li data-id="'.$child->term_id.'" id="hmh_folder_child_'.$child->term_id.'" class="hmh_folder_child "><a href="javascript:void(0)"><div><i class="filebase-iconfolder"></i><span class="hmh-folder-child-name">'.$child->name.'</span><strong class="hmh_number_of_attachment">'.$child->count.'</strong></div></a></li>';
    }
    $html .='</ul></li>';
    if (is_wp_error($checkERROR)) {
        echo "error";
    } else {
        wp_send_json_success($html);
    }
    wp_die();
}
endif;

if ( ! function_exists( 'filebase_add_attachment_category' ) ) :
add_action('add_attachment', 'filebase_add_attachment_category');
function filebase_add_attachment_category($post_ID){
    $hmh_Folder = isset($_REQUEST["filebaseULFolder"]) ? $_REQUEST["filebaseULFolder"] : null;
    if (is_null($hmh_Folder)) {
        $hmh_Folder = isset($_REQUEST["filebase_hmh_folder"]) ? $_REQUEST["filebase_hmh_folder"] : null;
    }
    if ($hmh_Folder !== null) {
        $hmh_Folder = (int) $hmh_Folder;
        if ($hmh_Folder > 0) {
            wp_set_object_terms($post_ID, $hmh_Folder, FILEBASE_TAX_FOLDER, false);
        }
    }
}
endif;

if ( ! function_exists( 'filebase_get_list_terms' ) ) :
add_action('wp_ajax_filebase_get_list_terms', 'filebase_get_list_terms');
function filebase_get_list_terms(){
    $object_ids =  250;
    $terms = get_terms(FILEBASE_TAX_FOLDER, array(
        'hide_empty' => false, 
    ));
    if (is_wp_error($terms)) {
        echo "error";
    } else {
        $ar = array('term_id' => 'unset', 'count' => filebase_getNumberOfpostNoTerm());
        array_push($terms,$ar);
        wp_send_json_success(array($terms));
    }
    wp_die();
}
endif;

if ( ! function_exists( 'filebase_update_option_manual' ) ) :
    add_action('wp_ajax_filebase_update_option_manual', 'filebase_update_option_manual');
    function filebase_update_option_manual(){
        $option_name = 'filebase_option_load_manual';
        $option_value = 0;
        $option_exists = (get_option($option_name, null));
			if ($option_exists !== null) {
                $check = update_option($option_name, $option_value);
			} else {
                $check =add_option($option_name, $option_value);
			}
        wp_die();
    }
endif;
